#!BPY

"""
Name: 'Box'
Blender: 232
Group: 'Mesh'
Tooltip: 'Array'
"""


#********Importovani Knihoven****
import Blender 
from Blender import NMesh
import whrandom

#**********KONSTANTY*******
uhel_const=57.296
#**************************
# ****Velikost pole****
pocet_x=3
pocet_y=3
pocet_z=3
##########################

# ******Offset objektu
krok_x=3
krok_y=3
krok_z=3
# *****Mira nahody offsetu
krok_rand_x=0
krok_rand_y=0
krok_rand_z=0

# *****Zmena velikosti****
scale_x=1
scale_y=1
scale_z=1

# *****Mira nahody pro zmenu velikosti zadavanych v hodnotach scale***
scale_rand_x_min=1.0
scale_rand_x_max=1.0
scale_rand_y_min=1.0
scale_rand_y_max=1.0
scale_rand_z_min=1.0
scale_rand_z_max=1.0

# *****Zmena rotace*****
rot_x=0
rot_y=0
rot_z=0

# *****Mira nahody pro rotaci ve stupnich***
rot_rand_x_min=0
rot_rand_x_max=0
rot_rand_y_min=0
rot_rand_y_max=0
rot_rand_z_min=0
rot_rand_z_max=0




# *****Hlavni program
whrandom.seed(2,3,4)
try:
  scene = Blender.Scene.getCurrent()

  Ozero=Blender.Object.GetSelected()[0]
  nomdelobjet=Ozero.getName()
  Mesh=Blender.NMesh.GetRawFromObject(nomdelobjet)

  for z in range (0,pocet_z):
	  for y in range (0,pocet_y):
		  for x in range (0,pocet_x):
			 #Prepocitani miry nahody pro offset
			 krok_rand_x2=krok_rand_x*whrandom.random()
			 krok_rand_y2=krok_rand_y*whrandom.random()
			 krok_rand_z2=krok_rand_z*whrandom.random()

			 #Prepocitani miry nahody pro rotaci
			 rot_rand_x2=(rot_rand_x_min+((rot_rand_x_max-rot_rand_x_min)*whrandom.random()))/uhel_const
			 rot_rand_y2=(rot_rand_y_min+((rot_rand_y_max-rot_rand_y_min)*whrandom.random()))/uhel_const
			 rot_rand_z2=(rot_rand_z_min+((rot_rand_z_max-rot_rand_z_min)*whrandom.random()))/uhel_const

			 #Prepocitani miry nahody pro zmenu velikosti
			 scale_rand_x2=scale_rand_x_min+((scale_rand_x_max-scale_rand_x_min)*whrandom.random())
			 scale_rand_y2=scale_rand_y_min+((scale_rand_y_max-scale_rand_y_min)*whrandom.random())
			 scale_rand_z2=scale_rand_z_min+((scale_rand_z_max-scale_rand_z_min)*whrandom.random())

			 
			 Obis = Blender.Object.New ('Mesh')
	 		 Obis.link(Mesh)
 			 Obis.setSize(Ozero.getSize()[0]*scale_x*scale_rand_x2,Ozero.getSize()[1]*scale_y*scale_rand_y2,Ozero.getSize()[2]*scale_z*scale_rand_z2)
 			 Obis.setEuler(Ozero.getEuler()[0]+rot_x/uhel_const+rot_rand_x2,Ozero.getEuler()[1]+rot_y/uhel_const+rot_rand_y2,Ozero.getEuler()[2]+rot_z/uhel_const+rot_rand_z2)
 		  	 Obis.setLocation(Ozero.getMatrix()[3][0]+krok_x*x+krok_rand_x2,Ozero.getMatrix()[3][1]+krok_y*y+krok_rand_y2,Ozero.getMatrix()[3][2]+krok_z*z+krok_rand_z2)
 		 	 scene.link (Obis) 



except:
  print "not a mesh or no object selected"
 
Blender.Redraw()